package cn.com.infosec.jce.provider;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.util.encoders.Base64;
import java.io.IOException;
import java.io.InputStream;

public class PEMUtil {
   private final String _header1;
   private final String _header2;
   private final String _footer1;
   private final String _footer2;

   PEMUtil(String type) {
      this._header1 = "-----BEGIN " + type + "-----";
      this._header2 = "-----BEGIN X509 " + type + "-----";
      this._footer1 = "-----END " + type + "-----";
      this._footer2 = "-----END X509 " + type + "-----";
   }

   private String readLine(InputStream in) {
      StringBuffer var3;
      var3 = new StringBuffer.<init>();

      int var2;
      do {
         while((var2 = in.read()) != 13 && var2 != 10 && var2 >= 0) {
            if (var2 != 13) {
               var3.append((char)var2);
            }
         }
      } while(var2 >= 0 && var3.length() == 0);

      return var2 < 0 ? null : var3.toString();
   }

   ASN1Sequence readPEMObject(InputStream in) {
      StringBuffer var2;
      var2 = new StringBuffer.<init>();

      String var3;
      while((var3 = this.readLine(in)) != null && !var3.equals(this._header1) && !var3.equals(this._header2)) {
      }

      while((var3 = this.readLine(in)) != null && !var3.equals(this._footer1) && !var3.equals(this._footer2)) {
         var2.append(var3);
      }

      if (var2.length() != 0) {
         DERObject var4;
         if ((var4 = (new ASN1InputStream(Base64.decode(var2.toString()))).readObject()) instanceof ASN1Sequence) {
            return (ASN1Sequence)var4;
         } else {
            throw new IOException("malformed PEM data encountered");
         }
      } else {
         return null;
      }
   }
}
